/*     new2bru.c Convert new brl/htm to bru format
(c) 2022 Duxbury Systems, Inc
Written by David Holladay 
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <io.h>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <io.h>
#define tags 129

FILE *fi,*fo;
char linep[8000],dos[1000],search[100];
int c, j,j0,k,p,pt,num,spot,last=1,lct,kf,kt,debug=0,debug2=0,pval=45;
char *src,*spc,*p1,*p2,*p3,*p4,*p5;

char *htm[tags]={
	"<brlhtm>",
	"<p>",
	"</p>",
	"<p para>",
	"</p para>",
	"<para>",
	"</para>",
	"<p lt>",
	"<|->",
	"<p l>",
	"<list>",
	"</list>",
	"<li>",
	"</li>", //to null
	"<li 2>",
	"<li 3>",
	"<li 4>",
	"<title>", 
	"</title>",
	"<h1>","</h1>","<h2>","</h2>","<h3>","</h3>","<h4>","</h4>",
	"<ol>", 
	"</ol>", 
	"<ul>", "</ul>", 
	"<center>", "</center>",
	"<html>", "</html>", 
	"<head>", "</head>", 
	"<body>", "</body>",
	"<runninghead>","<RunningHead>","</runninghead>","</RunningHead>",
	"<blockquote>", "</blockquote>", 
	"<|no-par>", "<|spacing>","<|compress>",
	"<brlinline>","</brlinline>",
	"<compinline>","</compinline>",
	"<ndt>", 
	"</ndt>", 
	"<table>",
	"</table>",
	"<tr><td>", "<tr><th>", 
	"<tr>", "</tr>", 
	"<td>", "</td>", 
	"<th>", "</th>", 
	"<tp.general>",
	"</tp.general>",
	"<hr>", 
	"<br>", 
	"<br />",
	"<a href=", 
	"</a>",
	"</a`>",
	"<contents>","</contents>",
	"<toc1>","</toc1>","<toc2>","</toc2>","<toc3>","</toc3>","<toc4>","</toc4>",
	"<pg-num>",
	"<pg>",

	"<arabic>","</arabic>",
	"<biblical-langs>","</biblical-langs>",
	"<french>","</french>",
	"<french2>","</french2>",
	"<german>","</german>",
	"<german2>","<german2>",
	"<greek>","</greek>",
	"<hebrew>","</hebrew>",
	"<hindi>","</hindi>",
	"<ipa>","</ipa>",
	"<italian>","</italian>",
	"<latin>","</latin>",
	"<math>","</math>",
	"<portuguese>","</portuguese>",
	"<russian>","</russian>",
	"<spanish>","</spanish>",
	"<spanish2>","</spanish2>",	

	"<note>","</note>",
	"<tnote>","</tnote>",
	"<hyperlink>","</hyperlink>",
	"<tm>","<h>",
	"<uoq~201c>",
	"<q~_>",
	"<null>"
	/*
	"<>","</>",
	*/
};
char *dbt[tags]={
	"",
	"|es~para.",
	"|ee~para.",
	"|es~para. ",
	"|ee~para.",
	"|es~para.",
	"|ee~para.",
	"|< ",
	"|-",
	"|l ",
	"|es~list.","|ee~list.", //to null
	"|l |hl1","", //to null
	"|l |hl2",
	"|l |hl3",
	"|l |hl4",
	"|es~tp.title. ", 
	"|ee~tp.title. ",
	"|es~h1. ","|ee~h1.","|es~h2. ","|ee~h2.","|es~h3. ","|ee~h3.","|es~h4. ","|ee~h4.",
	"|es~ol",  //ol 17
	"|ee~ol",
	"|es~list.",
	"|ee~list.",
	"|es~center ",
	"|ee~center ",
	"|es~html",
	"|ee~html",
	"|es~head",
	"|ee~head",
	"|es~body",
	"|ee~body",
	"|es~RunningHead.",
	"|es~RunningHead.",
	"|ee~RunningHead.",
	"|ee~RunningHead.",
	"|es~blockquote",
	"|ee~blockquote",
	"|no-par", 
	"|spacing ",
	"|compress ",
	"|es~brlinline",
	"|ee~brlinline`",
	"|es~compinline ",
	"|ee~compinline ",
	"|es~ndt",
	"|ee~ndt",
	"|htbs;r:0:0:b:n:a",
	"|htbe",
	"|l ","|l ",
	"|l ","",
	"|>",
	"",
	"|>",
	"",
	"|es~tp.general.",
	"|ee~tp.general.",
	"|es~hr", 
	"|<",
	"|<",
	"|es~a","|ee~a","|ee~a",
	"|es~TOC:marker.","|ee~TOC:marker.",
	"|hl1 ","",
	"|hl2 ","",
	"|hl3 ","",
	"|hl4 ","",
	"|fr;p~\". ",
	"|pg",

	"|lnb~ara ","|lnb~ ",
	"|lnb~qbi ","|lnb~ ",
	"|es~french ","|ee~french ",
	"|lnb~fra-xuf ","|lnb~ ",
	"|es~german ","|ee~german ",
	"|lnb~deu ","|lnb~ ",
	"|lnb~ell ","|lnb~ ",
	"|lnb~heb-is ","|lnb~ ",
	"|lnb~hin ","|lnb~ ",
	"|lnb~qip ","|lnb~ ",
	"|es~italian ","|ee~italian ",
	"|es~latin ","|ee~latin ",
	"|es~math ","|ee~math ",
	"|es~portuguese ","|ee~portuguese ",
	"|lnb~rus ","|lnb~ ",
	"|es~spanish ","|ee~spanish ",
	"|lnb~spa ","|lnb~ ",

	"|es~note.","|ee~note.",
	"|es~tnote","|ee~tnote",
	"|es~hyperlink ","|ee~hyperlink ",
	"<tm>","<h>",
	"|uoq~201c",
	".-",
	"|null"
};
// array "what" used by command line to generate documentation
char *what[tags]={
	"required trigger",
	"start body text paragraph",
	"end paragraph",
	"start body text paragraph",
	"end paragraph",
	"start body text paragraph",
	"end paragraph",
	"alternate paragraph marker",
	"hard hyphen",
	"alternate paragraph marker",
	"list item (ordered or unordered)","end list item",
	"list item (ordered or unordered)","end list item",
	"list item level 2",
	"list item level 3",
	"list item level 4as",
	"start title","end title",
	"heading level 1","end heading level 1",
	"heading level 2","end heading level 2",
	"heading level 3","end heading level 3",
	"heading level 4","end heading level 4",
	"start ordered list","end ordered list",
	"start unordered list","end unordered list",
	"start centering","end centering",
	"start html (html group)","end html (html group)","start head (html group)","end head (html group)",
	"start body (html group)","end body (html group)",
	"start running head","start running head","end running head","end running head",
	"start block quote","end block quote",
	"required by DBT","required by DBT","required by DBT",
	"start braille","end braille",
	"start computer notation","end computer notation",
	"start dictionary word","end dictionary word",
	"start table (table group)","end table (table group)",
	"start table row raw (table group)","end table row raw (table group)",
	"start table row (table group)","end table row (table group)",
	"start table item (table group)","end table item (table group)",
	"start table column label item (table group)","end table column label item (table group)",
	"title","end title",
	"horizontal rule (html group)",
	"line break",
	"line break",
	"start link (html group)","end link (html group)","end link (html group)",
	"start entire toc","end entire toc",
	"toc level 1","",
	"toc level 2","",
	"toc level 3","",
	"toc level 4","",
	"page#",
	"page tab",
	"start Arabic","end Arabic",
	"start Biblical Languages","end Biblical Languages",
	"start French style","end French style",
	"start French","end French",
	"start German style","end German style",
	"start German","end German",
	"start Greek","end Greek",
	"start Hebrew","end Hebrew",
	"start Hindi","end Hindi",
	"start IPA","end IPA",
	"start Italian style","end Italian style",
	"start Latin style","end Latin style",
	"start math style","end math style",
	"start Portuguese style","end Portuguese style",
	"start Russian","end Russian",
	"start Spanish style","end Spanish style",
	"start Spanish","end Spanish",
	"start note","end note",
	"start hyperlink","end hyperlink",
	"start transcriber note","end transcriber note",
	"entry for nightmare","entry for hard",
	"grouping quotes",
	"underbar",
	"end of this list"};

	void main(int argc,char *argv[])
	{
		if (strstr(argv[argc-1],"?"))
		{
			printf("command line version\n");
			if (!strstr(argv[argc-1],"??")) printf("\nConvert new brl/htm to bru format\n\n");
			if (strstr(argv[argc-1],"??")) printf("<!-- zzz-->\n<table class=\"lead\" border=\"2\">\n<tr><th>#<th>From<th>To DBT<th>Format Role</tr>\n");
			k=0;
			while (k<(tags)) 
		 {
			 if (strstr(argv[argc-1],"??")) 
			 {
				 if (htm[k][4]=='<') printf("<tr><td>%i<td>&lt;t%c>&lt;%s<td>%s<td>%s</td>\n",k+1,htm[k][2],&htm[k][5],&dbt[k][0],&what[k][0]); 
				 else printf("<tr><td>%i<td>&lt;%s<td>%s<td>%s</td>\n",k+1,&htm[k][1],&dbt[k][0],&what[k][0]); 
			 }
			 else printf("%i  %s   %s  %s\n",k,&htm[k][0],&dbt[k][0],&what[k][0]); 
			 k++;
		 }
			if (strstr(argv[argc-1],"??")) printf("</table>\n\n");
// end comment
			return;
		}
		if (argc>1)
		{
			if (!argv[2])
			{
				printf("\nNull output file name.\n");
				return;
			}
			if ((fi=fopen(argv[1],"rt"))==NULL)
			{
				printf("\nCannot open input bts file: %s\n",argv[1]);
				return;
			}
			if ((fo=fopen(argv[2],"wt"))==NULL)
			{
				printf("\nCannot open temp output file: %s\n",argv[2]);
				return;
			}
		}
		printf("new2bru version 2.0\n");

		pt=0;
		while ((c=fgetc(fi))!=EOF)
		{	
			if (debug) pval=5000;
			//if (debug) printf("%c",c);
			if (c!=10) linep[pt]=c,linep[pt+1]=0,linep[pt+2]=0,linep[pt+3]=0,pt++;
			else
			{
				k=0,lct++;
				while (k<99) search[k]=linep[k],k++;
				search[99]=0;
				src=strstr(search,">");
				spc=strstr(search," ");
				if (src) *(src+1)=0;
				if (spc&&src&&!strstr("<p para>.<p lt>.<p l>.<li 2>.<li 3>.<li 4>",search)&&(spc<src)) search[0]=0;
//<img src="img745.jpg" >  
				
/*				if (strstr(search,"<img src="))
				{
					fprintf(fo,"|es~img. ");
					k=8;
					while (search[k]!=34) fprintf(fo,"%c",search[k++]);
					fprintf(fo,"|ee~img. ");
					search[0]=0,j=0;
				} */

				if (search[0]=='<')
				{
					k=0;
					while (k<tags)
					{
						if (strstr(search,&htm[k][0]))
						{
							// found in line
							last=k;
							fprintf(fo,"%s",&dbt[k][0]);
							j=strlen(&htm[k][0]);
				    		if (!strncmp(linep,"<tr><td>",8)) j=j+4;
							p=p+strlen(&dbt[k][0]);
							k=4000;
						}
						k++;
					}
					if (k<3999) // ie not found, < is text
					{
						search[strlen(search)-1]=0;
						fprintf(fo,"|es~%s. ",search+1);
						j=strlen(search)+1,p=strlen(search)+5;
					}
				}
				// if not < use last
				else
				{
					if (search[0]) fprintf(fo,"%s ",&dbt[last][0]);
					j=0,p=0;
				}
				while (linep[j])
				{
					c=linep[j];
					search[0]=c;
					if (c=='<')
					{
						k=0;
						while (k<99) search[k]=linep[j+k],k++;
						search[99]=0;
						spc=strstr(search," ");
						src=strstr(search,">");
						p3=strstr(search+1,"<");
						p4=strstr(search+1,"\">");
						p5=strstr(search+1,".>");
						if (src) *(src+1)=0;
						else {search[0]='z'; /*printf("kn1\n");*/}						
						if (spc&&src&&!strstr("<p para>.</p para>.<p lt>.<p l>.<li 2>.<li 3>.<li 4>",search)&&(spc<src)) search[0]='z';
						if (p3&&src&&(p3<(src))) {search[0]='z'; /*printf("kn3 %s\n",search);*/}
						if (p4&&src&&(p4<(src))) {search[0]='z'; /*printf("xx %s\n",search);*/}
						if (p5&&src&&(p5<(src))) {search[0]='z'; /*printf("xx %s\n",search);*/}
					}
					if (search[0]=='<')
					{
						k=0;
						while (k<tags)
						{
							if (strstr(search,&htm[k][0]))
							{
								if (src) *(src)=0;
								if (htm[k][strlen(&htm[k][0])-1]=='~') 
								{
									fprintf(fo,"%s%s",&dbt[k][0],search+strlen(&htm[k][0]));
									j=j+strlen(search)+1; //strlen(&htm[k][0]);
									p=p+7;
								}
								else
								{
									fprintf(fo,"%s",&dbt[k][0]); 
									j0=j;
									j=j+strlen(&htm[k][0]);
									if (linep[j]==' ') j++;
									p=p+strlen(&dbt[k][0]);
									if (strstr(search,"a href="))
									{
										if (debug) printf("[[href]]");
										p1=linep+j+1, p2=strstr(p1,"\">")+2, p3=strstr(p1,"</a>");
										if (p2&&p3)
										{
											*(p2-2)=0,*(p3-3)=0;
											if (debug2) printf("\n[[%s]]\n",p1);
											kf=0,kt=0;
											while (*(p1+kf))
											{
												c=*(p1+kf);
												if (debug) printf("%c",c);
												if (!num&&(c>47)&&(c<57)) dos[kt++]='#',num=1,dos[kt]=c+48;
												if (num&&(c>48)&&(c<57)) dos[kt]=c+48;
												if (num&&(c==48)) dos[kt]='j';
												if (num&&(c>96)&&(c<107)) dos[kt++]=';',num=0;
												if ((c>96)&&(c<123)) dos[kt]=c,num=0;
												if (c=='/') dos[kt]='_',dos[kt+1]='/',kt++,num=0;
												if (c=='\\') dos[kt]='*',dos[kt+1]='/',kt++,num=0;
												if (c=='.') dos[kt]='4',num=0;
												if (c==' ') dos[kt]=' ',num=0;
												kf++,kt++;
												dos[kt]=0;
											}
											fprintf(fo,"%s \"<%s\"> ",p2,dos);
											if (debug ) printf("[%s \"<%s\">] ",p2,dos);
											j=p3-linep;
										}
									}
								}
								k=4000;
							}
							k++;
						}
						if (k<3999) // ie not found, < is text
						{
							c='s',k=1;
							search[strlen(search)-1]=0;
							if (search[1]=='|') 
							{
							fprintf(fo,"%s",search+k);
							j=j+strlen(search)+1,p=p+strlen(search)+1;
							}
							else
							{
							if (search[1]=='/') c='e',k=2;
							fprintf(fo,"|e%c~%s. ",c,search+k);
							j=j+strlen(search)+1,p=p+strlen(search)+5;
							}
						}
					}
					else
					{
						fprintf(fo,"%c",c);
						p++,j++;
					}
				}
				if (1==1) 
				{
					fprintf(fo,"\n"); 
					p=0;
				}
				pt=0,linep[0]=0,linep[1]=0,linep[2]=0;
			}
		}
		fclose(fi);
		fclose(fo);
	}

